import json
from django.core.management.base import BaseCommand
from lyrics.models import Album, Artista


class Command(BaseCommand):
    help = "Importa albumes desde un archivo JSON"

    def add_arguments(self, parser):
        parser.add_argument('archivo_json', type=str, help="Ruta del archivo JSON")

    def handle(self, *args, **kwargs):
        archivo_json = kwargs['archivo_json']

        try:
            with open(archivo_json, 'r', encoding='utf-8') as file:
                datos = json.load(file)

            self.stdout.write(self.style.WARNING(f"\nSe encontraron {len(datos)} albumes en el archivo '{archivo_json}'."))
            confirmar = input("¿Deseas continuar con la importación? (s/n): ").strip().lower()

            if confirmar != 's':
                self.stdout.write(self.style.ERROR("Importación cancelada."))
                return

            albumes_creados = 0
            for album_data in datos:
                try:
                    artista = Artista.objects.get(id=album_data["artist"])

                    creado = Album.objects.create(
                        artist_id=artista.id,
                        name=album_data['name'],
                        year=album_data['year'],
                        cover_image=album_data['cover_image'],
                    )
                    if creado:
                        albumes_creados += 1

                except Artista.DoesNotExist:
                    self.stderr.write(self.style.ERROR(f"Artista '{album_data['artista']}' no encontrado."))

            self.stdout.write(self.style.SUCCESS(f'Se importaron {albumes_creados} albumes correctamente.'))

        except FileNotFoundError:
            self.stderr.write(self.style.ERROR(f"El archivo {archivo_json} no se encontró."))
        except json.JSONDecodeError:
            self.stderr.write(self.style.ERROR("Error al leer el archivo JSON. Asegúrate de que el formato sea correcto."))
